#Datapack for Minecraft 1.14.4 Java Edition
#Created by domain2genus

#Test if the player is in water.
	execute as @a at @s if block ~ ~ ~ #d2g_mobs:d2g_seawater run tag @s add d2g_mobs_player_waterlogged
	execute as @a at @s unless block ~ ~ ~ #d2g_mobs:d2g_seawater run tag @s remove d2g_mobs_player_waterlogged
#Test if the player is in a variety of oak forest.
	tag @a[tag=d2g_mobs_oak] remove d2g_mobs_oak
	tag @a[scores={d2g_mobs_biomes=4}] add d2g_mobs_oak
	tag @a[scores={d2g_mobs_biomes=18}] add d2g_mobs_oak
	tag @a[scores={d2g_mobs_biomes=29}] add d2g_mobs_oak
	tag @a[scores={d2g_mobs_biomes=132}] add d2g_mobs_oak
	tag @a[scores={d2g_mobs_biomes=157}] add d2g_mobs_oak
	
#Keeping intentionally invisible mobs invisible.
	effect give @e[tag=d2g_mobs_invisible] invisibility 32768 1 true
	#Transitioning existing mobs (cheetahs) over to the new system.
		tag @e[type=silverfish,tag=d2g_mobs_cheetah] add d2g_mobs_invisible
#Keeping intentinally baby mobs as babies.
	execute as @e[tag=d2g_mobs_baby] run data merge entity @s {Age:-32768}
	
#Salmon tagging.
	execute as @a[nbt={SelectedItem:{id:"minecraft:salmon_spawn_egg"}}] at @s run tag @e[type=salmon,tag=!global.ignore,tag=!d2g_mobs_salmon,distance=..10] add d2g_mobs_salmon
	tag @e[type=salmon,nbt={FromBucket:1b},tag=!global.ignore] add d2g_mobs_salmon
	execute as @a[tag=!d2g_mobs_oak] unless entity @s[scores={d2g_mobs_biomes=129}] at @s run tag @e[type=salmon,tag=!global.ignore,tag=!d2g_mobs_salmon,distance=..30] add d2g_mobs_salmon
#Replacing salmon with common perch.
	execute at @a[tag=d2g_mobs_oak] as @e[type=salmon,tag=!global.ignore,tag=!d2g_mobs_salmon,distance=..35] at @s run summon tropical_fish ~ ~ ~ {Tags:["d2g_mobs_common_perch"],Variant:84345600,DeathLootTable:"d2g_mobs:entities/perch"}
	execute at @a[tag=d2g_mobs_oak] as @e[type=salmon,tag=!global.ignore,tag=!d2g_mobs_salmon,distance=..35] at @s if entity @e[tag=d2g_mobs_common_perch,distance=..1] run tp @s ~ -200 ~
#Replacing salmon with yellow perch.
	execute at @a[scores={d2g_mobs_biomes=129}] as @e[type=salmon,tag=!global.ignore,tag=!d2g_mobs_salmon,distance=..35] at @s run summon tropical_fish ~ ~ ~ {Tags:["d2g_mobs_yellow_perch"],Variant:67568384,DeathLootTable:"d2g_mobs:entities/perch"}
	execute at @a[scores={d2g_mobs_biomes=129}] as @e[type=salmon,tag=!global.ignore,tag=!d2g_mobs_salmon,distance=..35] at @s if entity @e[tag=d2g_mobs_yellow_perch,distance=..1] run tp @s ~ -200 ~
	
#Maintenance commands for nautilus.
	#Commands for the release of a nautilus from a Bucket of Nautilus.
	execute at @e[tag=d2g_mobs_bucket_nautilus] run summon minecraft:item ~ ~ ~ {Age:-32768,PickupDelay:32768,Tags:["d2g_mobs_nautilus","global.ignore"],Passengers:[{id:"minecraft:tropical_fish",Variant:427,CustomName:"{\"text\":\"domain2genus' d2g_mobs' nautilus' artificial intelligence\"}",Silent:1b,Tags:["d2g_mobs_nautilus","global.ignore"],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:32768}],Attributes:[{Name:generic.armor,Base:5}],DeathLootTable:"d2g_mobs:entities/nautilus"}],Item:{id:"minecraft:nautilus_shell",Count:1b}}
	kill @e[tag=d2g_mobs_bucket_nautilus]
	#Commands to move nautilus and keep its "artificial intelligence" hidden.
	effect give @e[type=tropical_fish,tag=d2g_mobs_nautilus] invisibility 32768
	execute as @e[type=item,tag=d2g_mobs_nautilus] at @s store result entity @s Rotation[0] float 1 run data get entity @e[type=tropical_fish,tag=d2g_mobs_nautilus,limit=1,sort=nearest] Rotation[0]
	execute as @e[type=item,tag=d2g_mobs_nautilus] at @s if block ^ ^ ^0.4 #d2g_mobs:d2g_seawater run tp @s ^ ^ ^0.02
	execute as @e[type=item,tag=d2g_mobs_nautilus] at @s unless block ~ ~0.65 ~ #d2g_mobs:d2g_seawater run tp @s ~ ~-0.01 ~
	execute as @e[type=tropical_fish,tag=d2g_mobs_nautilus] at @s unless entity @e[type=item,tag=d2g_mobs_nautilus,distance=..1] run kill @s
	#Commands for when a nautilus has been killed or placed in a  bucket.
	execute as @e[type=item,tag=d2g_mobs_nautilus] unless entity @s[nbt={Passengers:[{}]}] at @s unless entity @a[distance=..5,nbt={Inventory:[{tag:{display:{Name:'{"text":"domain2genus\' d2g_mobs\' nautilus\' artificial intelligence"}'}}}]}] run data merge entity @s {Age:0,PickupDelay:0}
	execute as @e[type=item,tag=d2g_mobs_nautilus] unless entity @s[nbt={Passengers:[{}]}] at @s unless entity @a[distance=..5,nbt={Inventory:[{tag:{display:{Name:'{"text":"domain2genus\' d2g_mobs\' nautilus\' artificial intelligence"}'}}}]}] run tag @s remove d2g_mobs_nautilus
	execute as @e[type=item,tag=d2g_mobs_nautilus] unless entity @s[nbt={Passengers:[{}]}] at @s if entity @a[distance=..5,nbt={Inventory:[{tag:{display:{Name:'{"text":"domain2genus\' d2g_mobs\' nautilus\' artificial intelligence"}'}}}]}] run data merge entity @s {Age:5999}
	tag @a[nbt={Inventory:[{tag:{display:{Name:'{"text":"domain2genus\' d2g_mobs\' nautilus\' artificial intelligence"}'}}}]}] add d2g_mobs_nautilus_bucket
	clear @a[tag=d2g_mobs_nautilus_bucket] minecraft:tropical_fish_bucket{display:{Name:'{"text":"domain2genus\' d2g_mobs\' nautilus\' artificial intelligence"}'}}
	give @a[tag=d2g_mobs_nautilus_bucket] minecraft:tropical_fish_bucket{EntityTag:{DeathLootTable:"d2g_mobs:entities/nautilus",Tags:["d2g_mobs_bucket_nautilus"],Variant:427,ActiveEffects:[{Id:14b,Amplifier:1b,Duration:32768}]},display: {Name:'{"text":"Bucket of Nautilus"}'}} 1
	tag @a[tag=d2g_mobs_nautilus_bucket] remove d2g_mobs_nautilus_bucket
	
#Turning rabbits into killer bunnies.
	execute as @e[type=rabbit,name="Caerbannog",tag=!d2g_mobs_killer_rabbit] run data merge entity @s {Health:20f,RabbitType:99,Tags:["d2g_mobs_killer_rabbit"],Attributes:[{Name:generic.maxHealth,Base:20}]}
	tag @e[tag=d2g_mobs_killer_rabbit,nbt=!{RabbitType:99}] remove d2g_mobs_killer_rabbit
	
#Making the ender dragon spawn phantoms.
	execute as @a[nbt={Dimension:1},gamemode=!spectator] at @s if entity @e[type=minecraft:ender_dragon,tag=!d2g_mobs_ender_phantom,nbt={DragonPhase:3},distance=..200] run summon minecraft:phantom ~ ~30 ~ {Health:30f,Size:5,Attributes:[{Name:generic.maxHealth,Base:35}],Tags:["d2g_mobs_ender_phantom"]}
	tag @e[type=minecraft:ender_dragon,nbt={DragonPhase:3}] add d2g_mobs_ender_phantom
	tag @e[type=minecraft:ender_dragon,nbt=!{DragonPhase:3}] remove d2g_mobs_ender_phantom

#Maintenance commands for cheetahs. Mostly to stop them from being breedable.
	execute as @e[type=ocelot,tag=d2g_mobs_cheetah] run data merge entity @s {Age:32768}
	execute as @e[type=ocelot,tag=d2g_mobs_cheetah,nbt={HurtTime:9s},nbt=!{Passengers:[{}]}] run data merge entity @s {Trusting:0}
#Killing the hostile AI of cheetahs.
	execute as @e[type=silverfish,tag=d2g_mobs_cheetah] at @s if block ~ ~ ~ #d2g_mobs:d2g_seawater run kill @s
	kill @e[type=silverfish,tag=d2g_mobs_cheetah,nbt={OnGround:1b}]
#Cheetah spawn egg.
	execute at @e[tag=d2g_mobs_egg_cheetah] run summon ocelot ~ ~ ~ {Tags:["d2g_mobs_cheetah"],Trusting:1,Age:32768,Attributes:[{Name:generic.movementSpeed,Base:0.42}],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:2,ShowParticles:0b},{Id:2b,Amplifier:2b,Duration:20,ShowParticles:0b}],DeathLootTable:"d2g_mobs:entities/cheetah",Passengers:[{id:"minecraft:silverfish",Silent:1b,Health:6f,Invulnerable:0b,Glowing:0b,CustomNameVisible:0b,DeathLootTable:"d2g_mobs:entities/cheetah",PersistenceRequired:1b,Tags:["d2g_mobs_cheetah","d2g_mobs_invisible"],CustomName:"{\"text\":\"Cheetah\"}",ActiveEffects:[{Id:14b,Amplifier:1b,Duration:655360,ShowParticles:0b}],Attributes:[{Name:generic.followRange,Base:40},{Name:generic.attackDamage,Base:5}]}]}
	kill @e[tag=d2g_mobs_egg_cheetah]
	
#Maintenance commands for piranha.
	execute as @e[tag=d2g_mobs_piranha] at @s facing entity @p[tag=d2g_mobs_player_waterlogged,tag=d2g_gamemode_survival,distance=..32] feet if block ^ ^ ^0.105 #d2g_mobs:d2g_seawater run tp @s ^ ^ ^0.1 ~ ~
	execute as @e[tag=d2g_mobs_piranha] at @s unless block ~ ~ ~ #d2g_mobs:d2g_seawater if block ~ ~1 ~ #d2g_mobs:d2g_seawater run tp @s ~ ~0.2 ~
	execute as @e[tag=d2g_mobs_piranha] at @s unless block ~-0.5 ~ ~ #d2g_mobs:d2g_seawater if block ~1 ~ ~ #d2g_mobs:d2g_seawater run tp @s ~0.2 ~ ~
	execute as @e[tag=d2g_mobs_piranha] at @s unless block ~0.5 ~ ~ #d2g_mobs:d2g_seawater if block ~-1 ~ ~ #d2g_mobs:d2g_seawater run tp @s ~-0.2 ~ ~
	execute as @e[tag=d2g_mobs_piranha] at @s unless block ~ ~ ~-0.5 #d2g_mobs:d2g_seawater if block ~ ~ ~1 #d2g_mobs:d2g_seawater run tp @s ~ ~ ~0.2
	execute as @e[tag=d2g_mobs_piranha] at @s unless block ~ ~ ~0.5 #d2g_mobs:d2g_seawater if block ~ ~ ~-1 #d2g_mobs:d2g_seawater run tp @s ~ ~ ~-0.2
	execute as @e[tag=d2g_mobs_piranha] at @s positioned ^ ^ ^0.4 if entity @p[distance=..0.4,scores={d2g_all_health=1},tag=d2g_gamemode_survival] at @p run summon minecraft:shulker_bullet ~ ~2.1 ~ {CustomNameVisible:0b,CustomName:"{\"text\":\"Piranha\"}"}
	execute as @e[tag=d2g_mobs_piranha] at @s positioned ^ ^ ^0.4 if entity @p[distance=..0.4,nbt=!{ActiveEffects:[{Id:19b}]},nbt=!{Health:1f},tag=d2g_gamemode_survival] run effect give @p minecraft:poison 2 0 true

#Summoning king piranhas about angler drowneds.
	execute as @e[type=drowned,tag=!global.ignore,tag=!d2g_mobs_angler,nbt={HandItems:[{id:"minecraft:fishing_rod"},{}]}] at @s if block ~1 ~1 ~1 #d2g_mobs:d2g_seawater run summon minecraft:tropical_fish ~1 ~1 ~1 {Variant:67633153,Tags:["d2g_mobs_piranha","d2g_mobs_angler"],DeathLootTable:"d2g_mobs:entities/piranha",Health:9f,Attributes:[{Name:generic.maxHealth,Base:12}]}
	execute as @e[type=drowned,tag=!global.ignore,tag=!d2g_mobs_angler,nbt={HandItems:[{id:"minecraft:fishing_rod"},{}]}] at @s if block ~-1 ~-1 ~-1 #d2g_mobs:d2g_seawater run summon minecraft:tropical_fish ~-1 ~-1 ~-1 {Variant:67633153,Tags:["d2g_mobs_piranha","d2g_mobs_angler"],DeathLootTable:"d2g_mobs:entities/piranha",Health:9f,Attributes:[{Name:generic.maxHealth,Base:12}]}
	tag @e[type=drowned,tag=!global.ignore,tag=!d2g_mobs_angler,nbt={HandItems:[{id:"minecraft:fishing_rod"},{}]}] add d2g_mobs_angler
	
#Making polar bears hostile.
	execute as @e[type=polar_bear,tag=!d2g_mobs_invisible,tag=!d2g_mobs_baby,tag=d2g_mobs_polar_bear,nbt=!{Passengers:[{}]}] at @s unless block ~ ~ ~ minecraft:water run tag @s remove d2g_mobs_polar_bear
	execute at @e[type=polar_bear,tag=!global.ignore,tag=!d2g_mobs_polar_bear] run summon minecraft:polar_bear ~ ~ ~ {Age:0,Tags:["d2g_mobs_polar_bear"],Passengers:[{id:"minecraft:polar_bear",Silent:1b,Invulnerable:1b,CustomNameVisible:0b,Tags:["d2g_mobs_polar_bear","d2g_mobs_baby","d2g_mobs_invisible"],Age:-32768,DeathLootTable:"d2g_mobs:entities/cheetah",ActiveEffects:[{Id:14b,Amplifier:1b,Duration:655360,ShowParticles:0b}]}]}
	execute as @e[tag=d2g_mobs_polar_bear] run data modify entity @s Attributes[{Base:20d,Name:"generic.followRange"}].Base set value 36d
	tp @e[type=polar_bear,tag=!global.ignore,tag=!d2g_mobs_polar_bear] ~ -200 ~
	kill @e[type=polar_bear,tag=d2g_mobs_invisible,tag=d2g_mobs_baby,nbt={OnGround:1b}]
	execute as @e[type=polar_bear,tag=d2g_mobs_invisible,tag=d2g_mobs_baby] at @s if block ~ ~ ~ minecraft:water run kill @s